﻿
Public Class Form1

    Private WithEvents mtimer As MilliTimerSimple

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        Text = AppTitleAndVersion()
        '
        Combo_InitFromEnum(cmb_Method, GetType(ChangeMethods))
        cmb_Method.SelectedIndex = 0
        '
        Load_INI()
        SetChangeMethod()
        SetParams()
        '
        mtimer = New MilliTimerSimple()
        mtimer.Interval = 2  ' Minimum useful interval is 2 mS
        mtimer.Start()
        '
        Timer1.Interval = 10
        Timer1.Start()

        EventsAreEnabled = True
        Refresh()
        Me.Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        Save_INI()
        If mtimer IsNot Nothing Then mtimer.Stop()
        Slots.WriteSlot(OutSlot, NAN_Sleep)
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private Sub txt_TextChanged(ByVal sender As System.Object, _
                                            ByVal e As System.EventArgs) _
                                                    Handles txt_OutputSlot.TextChanged, _
                                                            txt_MaxValue.TextChanged, _
                                                            txt_MinValue.TextChanged, _
                                                            txt_Speed.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        SetParams()
    End Sub

    Private Sub SetParams()
        OutSlot = txt_OutputSlot.NumericValueInteger
        MaxValue = CSng(txt_MaxValue.NumericValue)
        MinValue = CSng(txt_MinValue.NumericValue)
        Speed = CSng(txt_Speed.NumericValue * 2)
    End Sub

    ' ==============================================================================================================
    '   AUTO SAVE FOR ThereminoArm PARAMS - USING LostFocus
    ' ==============================================================================================================
    Private Sub ThereminoArmParams_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                            Handles txt_OutputSlot.LostFocus, _
                                                                                    txt_MaxValue.LostFocus, _
                                                                                    txt_MinValue.LostFocus, _
                                                                                    txt_Speed.LostFocus, _
                                                                                    cmb_Method.LostFocus


        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    ' ====================================================================================================
    '  Combo Methods
    ' ====================================================================================================
    Private Sub Combo_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Method.DropDown
        CType(sender, ComboBox).ItemHeight = 16
    End Sub
    Private Sub Combo_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Method.DropDownClosed
        CType(sender, ComboBox).ItemHeight = 12
    End Sub
    Private Sub Combo_Methods_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                    Handles cmb_Method.SelectionChangeCommitted
        If Not EventsAreEnabled Then Return
        SetChangeMethod()
    End Sub
    Private Sub SetChangeMethod()
        ChangeMethod = CType(cmb_Method.SelectedIndex, ChangeMethods)
    End Sub

    ' ==============================================================================================================
    '   TrackBars
    ' ==============================================================================================================
    Private Sub MyTrackBar1_Scroll(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyTrackBar1.Scroll
        If Not EventsAreEnabled Then Return
        WriteValueToSlot(MyTrackBar1.Value)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If ChangeMethod <> ChangeMethods.Manual Then
            EventsAreEnabled = False
            MyTrackBar1.Value = CInt(NewValue)
            EventsAreEnabled = True
        End If
    End Sub

    Private Sub MyTrackBar1_ValueChanged_1(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub
End Class