﻿Module Module_WaveGenerator


    Friend Enum ChangeMethods As Int32
        Manual
        Sinusoidal
        Semi_sinusoidal
        Triangular
        Sawtooth
        Square
    End Enum
    Friend ChangeMethod As ChangeMethods

    Friend NewValue As Single
    Friend MinValue As Single = 200
    Friend MaxValue As Single = 210
    Friend Speed As Single
    Friend OutSlot As Int32

    ' ====================================================================================================
    '   Auto Changer
    ' ====================================================================================================
    Friend Sub MilliTimerTick()
        Const kangle As Single = 2 * Math.PI / 1000.0F
        Static value As Single
        value = (value + Speed) Mod 1000
        Select Case ChangeMethod

            Case ChangeMethods.Sinusoidal
                NewValue = CSng(Math.Sin(value * kangle) * 500 + 500)
                WriteValueToSlot(NewValue)

            Case ChangeMethods.Semi_sinusoidal
                NewValue = CSng(Math.Abs(Math.Sin(value * kangle)) * 1000)
                WriteValueToSlot(NewValue)

            Case ChangeMethods.Triangular
                If value >= 500 Then
                    NewValue = CSng((1000 - value) * 2)
                Else
                    NewValue = value * 2
                End If
                WriteValueToSlot(NewValue)

            Case ChangeMethods.Sawtooth
                NewValue = value
                WriteValueToSlot(NewValue)

            Case ChangeMethods.Square
                If value >= 500 Then
                    NewValue = 1000
                Else
                    NewValue = 0
                End If
                WriteValueToSlot(NewValue)

        End Select



    End Sub

    Friend Sub WriteValueToSlot(ByVal v As Single)
        Slots.WriteSlot(OutSlot, MinValue + v / 1000.0F * (MaxValue - MinValue))
    End Sub


End Module
